/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSPDFImageRep;

import dstep.appkit.NSImageRep;
import dstep.foundation.NSData;
import dstep.foundation.NSGeometry;
import dstep.foundation.NSObjCRuntime;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPDFImageRep : NSImageRep
{
	mixin (ObjcWrap);

	static Object imageRepWithData (NSData pdfData)
	{
		return invokeObjcSelfClass!(Object, "imageRepWithData:", NSData)(pdfData);
	}

	NSPDFImageRep initWithData (NSData pdfData)
	{
		id result = invokeObjcSelf!(id, "initWithData:", NSData)(pdfData);
		return result is this.objcObject ? this : (result !is null ? new NSPDFImageRep(result) : null);
	}

	this (NSData pdfData)
	{
		super(NSPDFImageRep.alloc.initWithData(pdfData).objcObject);
	}

	NSData PDFRepresentation ()
	{
		return invokeObjcSelf!(NSData, "PDFRepresentation");
	}

	NSRect bounds ()
	{
		return invokeObjcSelf!(NSRect, "bounds");
	}

	void setCurrentPage (NSInteger page)
	{
		return invokeObjcSelf!(void, "setCurrentPage:", NSInteger)(page);
	}

	NSInteger currentPage ()
	{
		return invokeObjcSelf!(NSInteger, "currentPage");
	}

	NSInteger pageCount ()
	{
		return invokeObjcSelf!(NSInteger, "pageCount");
	}
}

