/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 1, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.applicationservices.coregraphics.CGLayer;

import dstep.corefoundation.CFDictionary;
import dstep.applicationservices.coregraphics.CGBase;
import dstep.applicationservices.coregraphics.CGContext;
import dstep.applicationservices.coregraphics.CGGeometry;

struct CGLayer;

alias CGLayer* CGLayerRef;

extern (C)
{
	CGLayerRef CGLayerCreateWithContext (CGContextRef context, CGSize size, CFDictionaryRef auxiliaryInfo);
	CGLayerRef CGLayerRetain (CGLayerRef layer);
	void CGLayerRelease (CGLayerRef layer);
	CGSize CGLayerGetSize (CGLayerRef layer);
	CGContextRef CGLayerGetContext (CGLayerRef layer);
	void CGContextDrawLayerInRect (CGContextRef context, CGRect rect, CGLayerRef layer);
	void CGContextDrawLayerAtPoint (CGContextRef context, CGPoint point, CGLayerRef layer);
	uint CGLayerGetTypeID ();
}