/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 12, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corefoundation.CFBitVector;

import dstep.corefoundation.CFBase;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc : id;

alias uint CFBit;
struct __CFBitVector;
alias __CFBitVector* CFBitVectorRef;
alias __CFBitVector* CFMutableBitVectorRef;

extern (C)
{
	uint CFBitVectorGetTypeID ();
	CFBitVectorRef CFBitVectorCreate (CFAllocatorRef allocator, char* bytes, int numBits);
	CFBitVectorRef CFBitVectorCreateCopy (CFAllocatorRef allocator, CFBitVectorRef bv);
	CFMutableBitVectorRef CFBitVectorCreateMutable (CFAllocatorRef allocator, int capacity);
	CFMutableBitVectorRef CFBitVectorCreateMutableCopy (CFAllocatorRef allocator, int capacity, CFBitVectorRef bv);
	int CFBitVectorGetCount (CFBitVectorRef bv);
	int CFBitVectorGetCountOfBit (CFBitVectorRef bv, CFRange range, uint value);
	ubyte CFBitVectorContainsBit (CFBitVectorRef bv, CFRange range, uint value);
	uint CFBitVectorGetBitAtIndex (CFBitVectorRef bv, int idx);
	void CFBitVectorGetBits (CFBitVectorRef bv, CFRange range, char* bytes);
	int CFBitVectorGetFirstIndexOfBit (CFBitVectorRef bv, CFRange range, uint value);
	int CFBitVectorGetLastIndexOfBit (CFBitVectorRef bv, CFRange range, uint value);
	void CFBitVectorSetCount (CFMutableBitVectorRef bv, int count);
	void CFBitVectorFlipBitAtIndex (CFMutableBitVectorRef bv, int idx);
	void CFBitVectorFlipBits (CFMutableBitVectorRef bv, CFRange range);
	void CFBitVectorSetBitAtIndex (CFMutableBitVectorRef bv, int idx, uint value);
	void CFBitVectorSetBits (CFMutableBitVectorRef bv, CFRange range, uint value);
	void CFBitVectorSetAllBits (CFMutableBitVectorRef bv, uint value);
}