/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSEnumerator;

import dstep.foundation.NSArray;
import dstep.foundation.NSObjCRuntime;
import dstep.foundation.NSObject;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

struct NSFastEnumerationState
{
	uint state;
	id* itemsPtr;
	ulong* mutationsPtr;
	ulong* extra;
}

const TNSExtendedEnumerator = `

	NSArray allObjects ()
	{
		return invokeObjcSelf!(NSArray, "allObjects");
	}
`;

class NSEnumerator : NSObject, INSFastEnumeration
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	Object nextObject ()
	{
		return invokeObjcSelf!(Object, "nextObject");
	}

	NSUInteger countByEnumeratingWithState (NSFastEnumerationState* state, id* stackbuf, NSUInteger len)
	{
		return invokeObjcSelf!(NSUInteger, "countByEnumeratingWithState:objects:count:", NSFastEnumerationState*, id*, NSUInteger)(state, stackbuf, len);
	}
	
	// TNSExtendedEnumerator
	NSArray allObjects ()
	{
		return invokeObjcSelf!(NSArray, "allObjects");
	}
}

interface INSFastEnumeration
{
	NSUInteger countByEnumeratingWithState (NSFastEnumerationState* state, id* stackbuf, NSUInteger len);
}