/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 28, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.qtkit.QTKitDefines;

import dstep.objc.bridge.TypeEncoding;

// This is needed otherwise the enums will fail compiling with gdc
version (GNU)
{
	private
	{
		const __VideoMediaType = getOSType!("vide");
		const __SoundMediaType = getOSType!("soun");
		const __TextMediaType = getOSType!("text");
		const __BaseMediaType = getOSType!("gnrc");
		const __MPEGMediaType = getOSType!("MPEG");
		const __MusicMediaType = getOSType!("musi");
		const __TimeCodeMediaType = getOSType!("tmcd");
		const __SpriteMediaType = getOSType!("sprt");
		const __FlashMediaType = getOSType!("flsh");
		const __MovieMediaType = getOSType!("moov");
		const __TweenMediaType = getOSType!("twen");
		const __ThreeDeeMediaType = getOSType!("qd3d");
		const __SkinMediaType = getOSType!("skin");
		const __HandleDataHandlerSubType = getOSType!("hndl");
		const __PointerDataHandlerSubType = getOSType!("ptr ");
		const __NullDataHandlerSubType = getOSType!("null");
		const __ResourceDataHandlerSubType = getOSType!("rsrc");
		const __URLDataHandlerSubType = getOSType!("url ");
		const __AliasDataHandlerSubType = getOSType!("alis");
		const __WiredActionHandlerType = getOSType!("wire");
		const __kQTQuartzComposerMediaType = getOSType!("qtz ");
		const __TimeCode64MediaType = getOSType!("tc64");
		const __kQTFileTypeAIFF = getOSType!("AIFF");
		const __kQTFileTypeAIFC = getOSType!("AIFC");
		const __kQTFileTypeDVC = getOSType!("dvc!");
		const __kQTFileTypeMIDI = getOSType!("Midi");
		const __kQTFileTypePicture = getOSType!("PICT");
		const __kQTFileTypeMovie = getOSType!("MooV");
		const __kQTFileTypeText = getOSType!("TEXT");
		const __kQTFileTypeWave = getOSType!("WAVE");
		const __kQTFileTypeSystemSevenSound = getOSType!("sfil");
		const __kQTFileTypeMuLaw = getOSType!("ULAW");
		const __kQTFileTypeAVI = getOSType!("VfW ");
		const __kQTFileTypeSoundDesignerII = getOSType!("Sd2f");
		const __kQTFileTypeAudioCDTrack = getOSType!("trak");
		const __kQTFileTypePICS = getOSType!("PICS");
		const __kQTFileTypeGIF = getOSType!("GIFf");
		const __kQTFileTypePNG = getOSType!("PNGf");
		const __kQTFileTypeTIFF = getOSType!("TIFF");
		const __kQTFileTypePhotoShop = getOSType!("8BPS");
		const __kQTFileTypeSGIImage = getOSType!(".SGI");
		const __kQTFileTypeBMP = getOSType!("BMPf");
		const __kQTFileTypeJPEG = getOSType!("JPEG");
		const __kQTFileTypeJFIF = getOSType!("JPEG");
		const __kQTFileTypeMacPaint = getOSType!("PNTG");
		const __kQTFileTypeTargaImage = getOSType!("TPIC");
		const __kQTFileTypeQuickDrawGXPicture = getOSType!("qdgx");
		const __kQTFileTypeQuickTimeImage = getOSType!("qtif");
		const __kQTFileType3DMF = getOSType!("3DMF");
		const __kQTFileTypeFLC = getOSType!("FLC ");
		const __kQTFileTypeFlash = getOSType!("SWFL");
		const __kQTFileTypeFlashPix = getOSType!("FPix");
		const __kQTFileTypeMP4 = getOSType!("mpg4");
		const __kQTFileTypePDF = getOSType!("PDF ");
		const __kQTFileType3GPP = getOSType!("3gpp");
		const __kQTFileTypeAMR = getOSType!("amr ");
		const __kQTFileTypeSDV = getOSType!("sdv ");
		const __kQTFileType3GP2 = getOSType!("3gp2");
		const __kQTFileTypeAMC = getOSType!("amc ");
		const __kQTFileTypeJPEG2000 = getOSType!("jp2 ");
		const __kRawCodecType = getOSType!("raw ");
		const __kCinepakCodecType = getOSType!("cvid");
		const __kGraphicsCodecType = getOSType!("smc ");
		const __kAnimationCodecType = getOSType!("rle ");
		const __kVideoCodecType = getOSType!("rpza");
		const __kComponentVideoCodecType = getOSType!("yuv2");
		const __kJPEGCodecType = getOSType!("jpeg");
		const __kMotionJPEGACodecType = getOSType!("mjpa");
		const __kMotionJPEGBCodecType = getOSType!("mjpb");
		const __kSGICodecType = getOSType!(".SGI");
		const __kPlanarRGBCodecType = getOSType!("8BPS");
		const __kMacPaintCodecType = getOSType!("PNTG");
		const __kGIFCodecType = getOSType!("gif ");
		const __kPhotoCDCodecType = getOSType!("kpcd");
		const __kQuickDrawGXCodecType = getOSType!("qdgx");
		const __kAVRJPEGCodecType = getOSType!("avr ");
		const __kOpenDMLJPEGCodecType = getOSType!("dmb1");
		const __kBMPCodecType = getOSType!("WRLE");
		const __kWindowsRawCodecType = getOSType!("WRAW");
		const __kVectorCodecType = getOSType!("path");
		const __kQuickDrawCodecType = getOSType!("qdrw");
		const __kWaterRippleCodecType = getOSType!("ripl");
		const __kFireCodecType = getOSType!("fire");
		const __kCloudCodecType = getOSType!("clou");
		const __kH261CodecType = getOSType!("h261");
		const __kH263CodecType = getOSType!("h263");
		const __kDVCNTSCCodecType = getOSType!("dvc ");
		const __kDVCPALCodecType = getOSType!("dvcp");
		const __kDVCProPALCodecType = getOSType!("dvpp");
		const __kDVCPro50NTSCCodecType = getOSType!("dv5n");
		const __kDVCPro50PALCodecType = getOSType!("dv5p");
		const __kDVCPro100NTSCCodecType = getOSType!("dv1n");
		const __kDVCPro100PALCodecType = getOSType!("dv1p");
		const __kDVCPROHD720pCodecType = getOSType!("dvhp");
		const __kDVCPROHD1080i60CodecType = getOSType!("dvh6");
		const __kDVCPROHD1080i50CodecType = getOSType!("dvh5");
		const __kBaseCodecType = getOSType!("base");
		const __kFLCCodecType = getOSType!("flic");
		const __kTargaCodecType = getOSType!("tga ");
		const __kPNGCodecType = getOSType!("png ");
		const __kTIFFCodecType = getOSType!("tiff");
		const __kComponentVideoSigned = getOSType!("yuvu");
		const __kComponentVideoUnsigned = getOSType!("yuvs");
		const __kCMYKCodecType = getOSType!("cmyk");
		const __kMicrosoftVideo1CodecType = getOSType!("msvc");
		const __kSorensonCodecType = getOSType!("SVQ1");
		const __kSorenson3CodecType = getOSType!("SVQ3");
		const __kIndeo4CodecType = getOSType!("IV41");
		const __kMPEG4VisualCodecType = getOSType!("mp4v");
		const __k64ARGBCodecType = getOSType!("b64a");
		const __k48RGBCodecType = getOSType!("b48r");
		const __k32AlphaGrayCodecType = getOSType!("b32a");
		const __k16GrayCodecType = getOSType!("b16g");
		const __kMpegYUV420CodecType = getOSType!("myuv");
		const __kYUV420CodecType = getOSType!("y420");
		const __kSorensonYUV9CodecType = getOSType!("syv9");
		const __k422YpCbCr8CodecType = getOSType!("2vuy");
		const __k444YpCbCr8CodecType = getOSType!("v308");
		const __k4444YpCbCrA8CodecType = getOSType!("v408");
		const __k422YpCbCr16CodecType = getOSType!("v216");
		const __k422YpCbCr10CodecType = getOSType!("v210");
		const __k444YpCbCr10CodecType = getOSType!("v410");
		const __k4444YpCbCrA8RCodecType = getOSType!("r408");
		const __kJPEG2000CodecType = getOSType!("mjp2");
		const __kPixletCodecType = getOSType!("pxlt");
		const __kH264CodecType = getOSType!("avc1");
	}
}

enum
{
	VideoMediaType = getOSType!("vide"),
	SoundMediaType = getOSType!("soun"),
	TextMediaType = getOSType!("text"),
	BaseMediaType = getOSType!("gnrc"),
	MPEGMediaType = getOSType!("MPEG"),
	MusicMediaType = getOSType!("musi"),
	TimeCodeMediaType = getOSType!("tmcd"),
	SpriteMediaType = getOSType!("sprt"),
	FlashMediaType = getOSType!("flsh"),
	MovieMediaType = getOSType!("moov"),
	TweenMediaType = getOSType!("twen"),
	ThreeDeeMediaType = getOSType!("qd3d"),
	SkinMediaType = getOSType!("skin"),
	HandleDataHandlerSubType = getOSType!("hndl"),
	PointerDataHandlerSubType = getOSType!("ptr "),
	NullDataHandlerSubType = getOSType!("null"),
	ResourceDataHandlerSubType = getOSType!("rsrc"),
	URLDataHandlerSubType = getOSType!("url "),
	AliasDataHandlerSubType = getOSType!("alis"),
	WiredActionHandlerType = getOSType!("wire"),
	kQTQuartzComposerMediaType = getOSType!("qtz "),
	TimeCode64MediaType = getOSType!("tc64")
}

enum
{
	kQTFileTypeAIFF = getOSType!("AIFF"),
	kQTFileTypeAIFC = getOSType!("AIFC"),
	kQTFileTypeDVC = getOSType!("dvc!"),
	kQTFileTypeMIDI = getOSType!("Midi"),
	kQTFileTypePicture = getOSType!("PICT"),
	kQTFileTypeMovie = getOSType!("MooV"),
	kQTFileTypeText = getOSType!("TEXT"),
	kQTFileTypeWave = getOSType!("WAVE"),
	kQTFileTypeSystemSevenSound = getOSType!("sfil"),
	kQTFileTypeMuLaw = getOSType!("ULAW"),
	kQTFileTypeAVI = getOSType!("VfW "),
	kQTFileTypeSoundDesignerII = getOSType!("Sd2f"),
	kQTFileTypeAudioCDTrack = getOSType!("trak"),
	kQTFileTypePICS = getOSType!("PICS"),
	kQTFileTypeGIF = getOSType!("GIFf"),
	kQTFileTypePNG = getOSType!("PNGf"),
	kQTFileTypeTIFF = getOSType!("TIFF"),
	kQTFileTypePhotoShop = getOSType!("8BPS"),
	kQTFileTypeSGIImage = getOSType!(".SGI"),
	kQTFileTypeBMP = getOSType!("BMPf"),
	kQTFileTypeJPEG = getOSType!("JPEG"),
	kQTFileTypeJFIF = getOSType!("JPEG"),
	kQTFileTypeMacPaint = getOSType!("PNTG"),
	kQTFileTypeTargaImage = getOSType!("TPIC"),
	kQTFileTypeQuickDrawGXPicture = getOSType!("qdgx"),
	kQTFileTypeQuickTimeImage = getOSType!("qtif"),
	kQTFileType3DMF = getOSType!("3DMF"),
	kQTFileTypeFLC = getOSType!("FLC "),
	kQTFileTypeFlash = getOSType!("SWFL"),
	kQTFileTypeFlashPix = getOSType!("FPix"),
	kQTFileTypeMP4 = getOSType!("mpg4"),
	kQTFileTypePDF = getOSType!("PDF "),
	kQTFileType3GPP = getOSType!("3gpp"),
	kQTFileTypeAMR = getOSType!("amr "),
	kQTFileTypeSDV = getOSType!("sdv "),
	kQTFileType3GP2 = getOSType!("3gp2"),
	kQTFileTypeAMC = getOSType!("amc "),
	kQTFileTypeJPEG2000 = getOSType!("jp2 ")
}

enum
{
	codecLosslessQuality = 0x00000400,
	codecMaxQuality = 0x000003FF,
	codecMinQuality = 0x00000000,
	codecLowQuality = 0x00000100,
	codecNormalQuality = 0x00000200,
	codecHighQuality = 0x00000300
}

enum
{
	kRawCodecType = getOSType!("raw "),
	kCinepakCodecType = getOSType!("cvid"),
	kGraphicsCodecType = getOSType!("smc "),
	kAnimationCodecType = getOSType!("rle "),
	kVideoCodecType = getOSType!("rpza"),
	kComponentVideoCodecType = getOSType!("yuv2"),
	kJPEGCodecType = getOSType!("jpeg"),
	kMotionJPEGACodecType = getOSType!("mjpa"),
	kMotionJPEGBCodecType = getOSType!("mjpb"),
	kSGICodecType = getOSType!(".SGI"),
	kPlanarRGBCodecType = getOSType!("8BPS"),
	kMacPaintCodecType = getOSType!("PNTG"),
	kGIFCodecType = getOSType!("gif "),
	kPhotoCDCodecType = getOSType!("kpcd"),
	kQuickDrawGXCodecType = getOSType!("qdgx"),
	kAVRJPEGCodecType = getOSType!("avr "),
	kOpenDMLJPEGCodecType = getOSType!("dmb1"),
	kBMPCodecType = getOSType!("WRLE"),
	kWindowsRawCodecType = getOSType!("WRAW"),
	kVectorCodecType = getOSType!("path"),
	kQuickDrawCodecType = getOSType!("qdrw"),
	kWaterRippleCodecType = getOSType!("ripl"),
	kFireCodecType = getOSType!("fire"),
	kCloudCodecType = getOSType!("clou"),
	kH261CodecType = getOSType!("h261"),
	kH263CodecType = getOSType!("h263"),
	kDVCNTSCCodecType = getOSType!("dvc "),
	kDVCPALCodecType = getOSType!("dvcp"),
	kDVCProPALCodecType = getOSType!("dvpp"),
	kDVCPro50NTSCCodecType = getOSType!("dv5n"),
	kDVCPro50PALCodecType = getOSType!("dv5p"),
	kDVCPro100NTSCCodecType = getOSType!("dv1n"),
	kDVCPro100PALCodecType = getOSType!("dv1p"),
	kDVCPROHD720pCodecType = getOSType!("dvhp"),
	kDVCPROHD1080i60CodecType = getOSType!("dvh6"),
	kDVCPROHD1080i50CodecType = getOSType!("dvh5"),
	kBaseCodecType = getOSType!("base"),
	kFLCCodecType = getOSType!("flic"),
	kTargaCodecType = getOSType!("tga "),
	kPNGCodecType = getOSType!("png "),
	kTIFFCodecType = getOSType!("tiff"),
	kComponentVideoSigned = getOSType!("yuvu"),
	kComponentVideoUnsigned = getOSType!("yuvs"),
	kCMYKCodecType = getOSType!("cmyk"),
	kMicrosoftVideo1CodecType = getOSType!("msvc"),
	kSorensonCodecType = getOSType!("SVQ1"),
	kSorenson3CodecType = getOSType!("SVQ3"),
	kIndeo4CodecType = getOSType!("IV41"),
	kMPEG4VisualCodecType = getOSType!("mp4v"),
	k64ARGBCodecType = getOSType!("b64a"),
	k48RGBCodecType = getOSType!("b48r"),
	k32AlphaGrayCodecType = getOSType!("b32a"),
	k16GrayCodecType = getOSType!("b16g"),
	kMpegYUV420CodecType = getOSType!("myuv"),
	kYUV420CodecType = getOSType!("y420"),
	kSorensonYUV9CodecType = getOSType!("syv9"),
	k422YpCbCr8CodecType = getOSType!("2vuy"),
	k444YpCbCr8CodecType = getOSType!("v308"),
	k4444YpCbCrA8CodecType = getOSType!("v408"),
	k422YpCbCr16CodecType = getOSType!("v216"),
	k422YpCbCr10CodecType = getOSType!("v210"),
	k444YpCbCr10CodecType = getOSType!("v410"),
	k4444YpCbCrA8RCodecType = getOSType!("r408"),
	kJPEG2000CodecType = getOSType!("mjp2"),
	kPixletCodecType = getOSType!("pxlt"),
	kH264CodecType = getOSType!("avc1")
}

enum
{
	graphicsModeStraightAlpha = 256,
	graphicsModePreWhiteAlpha = 257,
	graphicsModePreBlackAlpha = 258,
	graphicsModeComposition = 259,
	graphicsModeStraightAlphaBlend = 260,
	graphicsModePreMulColorAlpha = 261,
	graphicsModePerComponentAlpha = 272
}

